"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
function reduce(source, callback, initialValue) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        let [index, accumulator] = [-1, initialValue];
        try {
            for (var source_1 = tslib_1.__asyncValues(source), source_1_1; source_1_1 = yield source_1.next(), !source_1_1.done;) {
                const element = yield source_1_1.value;
                accumulator = ++index === 0 && initialValue === undefined ?
                    element :
                    callback(accumulator, element, index);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (source_1_1 && !source_1_1.done && (_a = source_1.return)) yield _a.call(source_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (initialValue === undefined && index === -1) {
            throw new Error('Sequence contains no elements.');
        }
        return accumulator;
        var e_1, _a;
    });
}
exports.reduce = reduce;

//# sourceMappingURL=reduce.js.map
